unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, ExtCtrls, ShellAPI, FileCtrl, ToolBox, ImgList, StdCtrls,
  Shlobj, Param, ActiveX;

const
  UndoMax = 16; // AhE̕ۑf[^

  CSIDL: array[0..10] of Integer = (CSIDL_DESKTOP, CSIDL_COMMON_DESKTOPDIRECTORY,
                                   CSIDL_PROGRAMS, CSIDL_COMMON_PROGRAMS,
                                   CSIDL_STARTUP, CSIDL_COMMON_STARTUP,
                                   CSIDL_PERSONAL,
                                   38, 43, 36, 1000);

type
  TFrameForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Close1: TMenuItem;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    ListView1: TListView;
    ImageList1: TImageList;
    Show1: TMenuItem;
    N16161: TMenuItem;
    N32321: TMenuItem;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label2: TLabel;
    Edit2: TEdit;
    Button2: TButton;
    Label3: TLabel;
    Edit3: TEdit;
    Button4: TButton;
    Label4: TLabel;
    Edit4: TEdit;
    Button6: TButton;
    Label5: TLabel;
    Edit5: TEdit;
    Button8: TButton;
    Button12: TButton;
    Label6: TLabel;
    Edit6: TEdit;
    Label7: TLabel;
    Parameter1: TParameter;
    N3: TMenuItem;
    N4: TMenuItem;
    Edit7: TMenuItem;
    A1: TMenuItem;
    Edit8: TEdit;
    Label8: TLabel;
    N2: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    L1: TMenuItem;
    N8: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    K1: TMenuItem;
    Delete1: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    F1: TMenuItem;
    Help1: TMenuItem;
    SearchforHelpOn1: TMenuItem;
    About1: TMenuItem;
    FontDialog1: TFontDialog;
    Button3: TButton;
    PopupMenu1: TPopupMenu;
    Rename1: TMenuItem;
    Button5: TButton;
    Button7: TButton;
    N11: TMenuItem;
    Timer1: TTimer;
    N12: TMenuItem;
    N13: TMenuItem;
    Open2: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    Rename2: TMenuItem;
    N19: TMenuItem;
    N20: TMenuItem;
    CtrlC1: TMenuItem;
    CtrlV1: TMenuItem;
    Del1: TMenuItem;
    ShiftDel1: TMenuItem;
    N21: TMenuItem;
    CtrlA1: TMenuItem;
    CtrlR1: TMenuItem;
    F11: TMenuItem;
    About2: TMenuItem;
    N22: TMenuItem;
    N23: TMenuItem;
    Button9: TButton;
    N24: TMenuItem;
    N25: TMenuItem;
    Panel3: TPanel;
    ComboBox1: TComboBox;
    Label9: TLabel;
    Button10: TButton;
    Button11: TButton;
    S1: TMenuItem;
    N31: TMenuItem;
    N26: TMenuItem;
    N27: TMenuItem;
    N28: TMenuItem;
    CtrlY1: TMenuItem;
    N29: TMenuItem;
    Space1: TMenuItem;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Option1: TMenuItem;
    Q1: TMenuItem;
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ListView1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Show1Click(Sender: TObject);
    procedure N16161Click(Sender: TObject);
    procedure N32321Click(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure Close1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure A1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure ListView1ColumnClick(Sender: TObject; Column: TListColumn);
    procedure Edit8KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure N5Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure L1Click(Sender: TObject);
    procedure K1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure F1Click(Sender: TObject);
    procedure SearchforHelpOn1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ListView1Edited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure Rename1Click(Sender: TObject);
    procedure ListView1Editing(Sender: TObject; Item: TListItem;
      var AllowEdit: Boolean);
    procedure Button5Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure Rename2Click(Sender: TObject);
    procedure Open2Click(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure N16Click(Sender: TObject);
    procedure N17Click(Sender: TObject);
    procedure N18Click(Sender: TObject);
    procedure CtrlC1Click(Sender: TObject);
    procedure CtrlV1Click(Sender: TObject);
    procedure Del1Click(Sender: TObject);
    procedure ShiftDel1Click(Sender: TObject);
    procedure CtrlA1Click(Sender: TObject);
    procedure CtrlR1Click(Sender: TObject);
    procedure F11Click(Sender: TObject);
    procedure About2Click(Sender: TObject);
    procedure N23Click(Sender: TObject);
    procedure N24Click(Sender: TObject);
    procedure N25Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure S1Click(Sender: TObject);
    procedure N31Click(Sender: TObject);
    procedure ComboBox1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure N26Click(Sender: TObject);
    procedure N27Click(Sender: TObject);
    procedure N28Click(Sender: TObject);
    procedure CtrlY1Click(Sender: TObject);
    procedure N29Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Q1Click(Sender: TObject);
  private
    { Private 錾 }
    function Hook(var Message: TMessage): Boolean;
  public
    { Public 錾 }
    MajorVersion: DWORD;
    SRecs: TSearchRecs;
    Icon: TIcon;
    WildCard: String;
    WildLen: Integer;
    WorkDir: String;
    SpecialDir: TStringList; // tH_i[p
    UndoFlag: Boolean; // AhEEhE True ɂȂtO
    UndoIndex: Integer; // AhẼCfbNXl
    UndoPath: TStringList; // AhEf[^i[p
    procedure GetSystemIcons(Size: Integer);
    procedure DispData(Path: String);
    procedure PaintData;
    procedure DispInfor(Index: Integer);
    procedure DoDeleteFiles(Undo: Boolean);
    function IndexOfOldPath(NewPath: String; OldPath: String): Integer;
    procedure CheckComboBox1;
    procedure UndoUpdate;
  end;

var
  FrameForm: TFrameForm;

implementation

uses Whereis, Grep;

{$R *.DFM}

{ w肳ꂽTCYŁAVXeACR 16 葱łB}
{ TCÝA16, 32, 48 ̂ꂩ̒lłȂ΂Ȃ܂B}

procedure TFrameForm.GetSystemIcons(Size: Integer);
var
  i, n: Integer;
  FileName: String;
begin
  n := Size;
  if not (n in [16, 32, 48]) then
    n := 16; // Default Size
  FileName := 'Shell32.dll';
  ImageList1.Clear;
  ImageList1.Width := n;
  ImageList1.Height := n;
  for i := 0 to 15 do // VXeACR 16 B
  begin
    Icon.Handle := HICON(ExtractIcon(HInstance, PChar(FileName), i));
    if not Icon.Empty then
      ImageList1.AddIcon(Icon);
  end;
end;

procedure TFrameForm.UndoUpdate;
var
  i: Integer;
begin
  if UndoFlag = True then
  begin
    UndoFlag := False;
    Exit; // ȂB
  end;

  if UndoIndex = UndoMax - 1 then // UndoIndex ́AUndoMax - 1 傫ȂȂB
  begin
    for i := 0 to UndoMax - 2 do
      UndoPath[i] := UndoPath[i + 1];
  end
  else
  begin
    for i := UndoMax - 1 downto UndoIndex + 2 do
      UndoPath[i] := UndoPath[i - 1];
    Inc(UndoIndex);
  end;
  UndoPath[UndoIndex] := SRecs.FullPath;
end;

procedure TFrameForm.DispData(Path: String);
var
  i, j, k: Integer;
  n, h: Integer;
  X, Y: Integer;
  OldPath: String;
  ListItem: TListItem;
begin
  if (Path <> '') and (not ValidPath(Path)) then // LȃpXł͂Ȃꍇ
  begin
    WorkDir := ''; // ł́AJgfBNgӖB
    WildCard := '*.*';
    WildLen := Length(WildCard);
    Edit8.Text := WildCard;
    Path := WorkDir + WildCard; // JgfBNg̑SẴt@C\B
  end;

  if SRecs.Path = Path then // pXĕ\悤ƂĂꍇ
  begin
    SRecs.Refresh;
    if Listview1.SelCount > 0 then
      j := ListView1.Selected.Index
    else
      j := 0;
  end
  else
  begin
    OldPath := SRecs.FullPath; // ύXÕtpX
    SRecs.Path := Path;
    j := IndexOfOldPath(SRecs.FullPath, OldPath);
    if j = -1 then
      j := 0;
  end;

  if SRecs.FullPath = '' then // hCu\
    WorkDir := ''
  else
    WorkDir := Copy(SRecs.FullPath, 1, Length(SRecs.FullPath) - (WildLen + 1));
  if (Length(WorkDir) = 2) and (WorkDir[2] = ':') then
    WorkDir := WorkDir + '\';

  if ListView1.Items.Count < SRecs.Count then
    n := ListView1.Items.Count
  else
    n := SRecs.Count;
  for i := 0 to n - 1 do
    ListView1.Items.Item[i].Selected := False;

  n := ListView1.Items.Count;
  if n > SRecs.Count then
  begin
    for i := n - 1 downto SRecs.Count do
      ListView1.Items.Delete(i);
  end
  else if n < SRecs.Count then
  begin
    for i := n + 1 to SRecs.Count do
    begin
      ListItem := ListView1.Items.Add;
      ListItem.Caption := ' ';
      ListItem.SubItems.Add(' ');
      ListItem.SubItems.Add(' ');
      ListItem.SubItems.Add(' ');
    end;
  end;

  PaintData;

  if ListView1.Items.Count > 0 then
  begin
    ListItem := ListView1.Items.Item[j];
    ListView1.Selected := ListItem;
    ListView1.ItemFocused := ListItem;

    X := -ListView1.Font.Height;
    Y := ListView1.Height + ListView1.Font.Height; // ŉs Y W
    ListItem := ListView1.GetItemAt(X, Y);
    if Assigned(ListItem) and (ListItem.Index < j) then
    begin
      i := ListItem.Index;
      h := j - i;
      Y := -ListView1.Font.Height * 2; // ŏs Y W
      ListItem := ListView1.GetItemAt(X, Y);
      k := ListItem.Index;
      h := h * ListView1.Height div (i - k + 1);
      ListView1.Scroll(0, h);
    end;
  end;

  UndoUpdate; // UndoPath ̃f[^XV葱
end;

procedure TFrameForm.PaintData;
var
  i: Integer;
  n, m: Integer;
  SS, NN: Int64;
  a: Integer;
  S: String;
  Dir: String;
  ListItem: TListItem;
  d: TDateTime;
  FileInfo: TSHFileInfo;
  ii: Word;
begin
  Dir := SRecs.FullPath;
  Dir := Copy(Dir, 1, Length(Dir) - WildLen);

  i := ImageList1.Count - 1;
  while i >= 16 do
  begin
    ImageList1.Delete(i);
    Dec(i);
  end;

  if SRecs.Path = '' then // ڑhCu\ꍇ
  begin
    for i := 0 to SRecs.Count - 1 do
    begin
      ListItem := ListView1.Items.Item[i];
      ListItem.Caption := SRecs.Recs[i].Name;

      n := SRecs.Recs[i].Size; // MB Pʂ̃TCY
      if n = -1 then // hCȕoĂȂꍇ
        ListItem.SubItems[0] := '---'
      else if n < 1024 then // TCYA1GB ȉ̏ꍇ
        ListItem.SubItems[0] := IntToStr(n) + 'MB'
      else
      begin
        m := n mod 1024;
        m := m * 10;
        m := m div 1024;
        n := n div 1024;
        if n = 0 then
          n := 1;
        ListItem.SubItems[0] := IntToStr(n) + '.' + IntToStr(m) + 'GB';
      end;

      ListItem.SubItems[1] := ' ';

      ListItem.SubItems[2] := ' ';

      ListItem.ImageIndex := SRecs.Recs[i].Time;
    end;
  end
  else  // ʏ̃fBNg\ꍇ
  begin
    for i := 0 to SRecs.Count - 1 do
    begin
      ListItem := ListView1.Items.Item[i];
      ListItem.Caption := SRecs.Recs[i].Name;

      n := SRecs.Recs[i].Size div 1024;
      if (n = 0) and (SRecs.Recs[i].Size > 0) then
        n := 1;
      if n < 1024 then // 1MB ȉ̏ꍇ
        ListItem.SubItems[0] := IntToStr(n) + 'KB'
      else
      begin
        n := n div 1024;
        if n = 0 then
          n := 1;
        ListItem.SubItems[0] := IntToStr(n) + 'MB';
      end;

      a := SRecs.Recs[i].Attr;
      S := '';
      if (a and faArchive) > 0 then
        S := S + 'A';
      if (a and faReadOnly) > 0 then
        S := S + 'R';
      if (a and faHidden) > 0 then
        S := S + 'H';
      if (a and faSysFile) > 0 then
        S := S + 'S';
     if (a and faDirectory) > 0 then
      begin
        S := S + 'D';
        ListItem.SubItems[0] := ' ';
      end;
      if (a and faVolumeID) > 0 then
      begin
        S := S + 'V';
        ListItem.SubItems[0] := ' ';
      end;
      if S = '' then
        S := ' ';
      ListItem.SubItems[1] := S;

      if FileTimeToDateTime(SRecs.Recs[i].FindData.ftLastWriteTime, d) then
        S := FormatDateTime('yyyy/mm/dd hh:nn:ss', d)
      else
        S := ' ';
      ListItem.SubItems[2] := S;

      if (a and faDirectory) > 0 then
        ListItem.ImageIndex := 3
      else
      begin
        S := Dir + SRecs.Recs[i].Name;
        if MajorVersion > 5 then // XP ȍ~ Windows ̏ꍇ
        begin
          ii := 0;
          Icon.Handle := HICON(ExtractIcon(HInstance, PChar(S), ii));
          if not Icon.Empty then
            ListItem.ImageIndex := ImageList1.AddIcon(Icon)
          else
            ListItem.ImageIndex := 0;
        end
        else
        begin
          SHGetFileInfo(PChar(S),
                        FILE_ATTRIBUTE_DIRECTORY,
                        FileInfo,
                        SizeOf(TSHFileInfo),
                        SHGFI_ICON);
          Icon.Handle := FileInfo.hIcon;
          ListItem.ImageIndex := ImageList1.AddIcon(Icon);
        end;
      end;
    end;
  end;

  S := IntToStr(SRecs.Count) + ' Object';
  if SRecs.Count <> 1 then
    S := S + 's';
  StatusBar1.Panels[0].Text := S;

  SS := 0;
  for i := 0 to SRecs.Count - 1 do
    SS := SS + SRecs.Recs[i].Size;
  if SRecs.Path = '' then
    SS := SS * (1024 * 1024);
  NN := SS;
  NN := NN div 1024;
  if (NN = 0) and (SS > 0) then
    NN := 1;
  if NN < 1024 then
    StatusBar1.Panels[1].Text := IntToStr(NN) + 'KB'
  else if NN < 1024 * 1024 then
  begin
    NN := NN div 1024;
    if NN = 0 then
      NN := 1;
    StatusBar1.Panels[1].Text := IntToStr(NN) + 'MB';
  end
  else
  begin
    NN := NN div (1024 * 1024);
    if NN = 0 then
      NN := 1;
    StatusBar1.Panels[1].Text := IntToStr(NN) + 'GB';
  end;

  StatusBar1.Panels[2].Text := SRecs.FullPath;
end;

procedure TFrameForm.DispInfor(Index: Integer);
var
  R: TSearchRec;
  DTime: TDateTime;
  Item: TListItem;
  DS: Int64;
begin
  if (Index < 0) or (Index > ListView1.Items.Count - 1) then
    Exit;

  Item := ListView1.Items.Item[Index];
  R := SRecs.Recs[Index];

  if SRecs.Path = '' then // ڑhCu\ꍇ
  begin
    Edit1.Text := Item.Caption;
    if R.Size = -1 then
      Edit6.Text := 'Incorrect Drive'
    else
    begin
      DS := FindDataSize(R);
      Edit6.Text := IntToStr(DS);
    end;
    Edit2.Text := ' ';
    Edit3.Text := ' ';
    Edit4.Text := ' ';
    Edit5.Text := ' ';
  end
  else
  begin
    Edit1.Text := Item.Caption;
    if (R.Attr and faDirectory) > 0 then
      Edit6.Text := ' '
    else
      Edit6.Text := IntToStr(R.Size);
    Edit2.Text := Item.SubItems[1];
    FileTimeToDateTime(R.FindData.ftCreationTime, DTime);
    Edit3.Text := FormatDateTime('yyyy/mm/dd hh:nn:ss', DTime);
    FileTimeToDateTime(R.FindData.ftLastAccessTime, DTime);
    Edit4.Text := FormatDateTime('yyyy/mm/dd hh:nn:ss', DTime);
    FileTimeToDateTime(R.FindData.ftLastWriteTime, DTime);
    Edit5.Text := FormatDateTime('yyyy/mm/dd hh:nn:ss', DTime);
  end;
end;

procedure TFrameForm.DoDeleteFiles(Undo: Boolean);
var
  i: Integer;
  Files: TStringList;
  Dir: String;
  ListItem: TListItem;
begin
  ListView1.SetFocus;
  if (ListView1.SelCount = 0) or (SRecs.FullPath = '') then
    Exit;

  Dir := Copy(SRecs.FullPath, 1, Length(SRecs.FullPath) - WildLen);

  Files := TStringList.Create;
  try
    for i := 0 to ListView1.Items.Count - 1 do
    begin
      ListItem := ListView1.Items.Item[i];
      if ListItem.Selected and ((SRecs.Recs[i].Attr and faVolumeID) = 0) then
        Files.Add(Dir + ListItem.Caption);
    end;
    i := DeleteFiles(Files, Undo);
  finally
    Files.Free;
  end;
  if i > 0 then
    DispData(SRecs.Path);
end;

{ ChJ[h܂ NewPath ̒ OldPath ̃fBNgAo }
{ ̃CfbNXԍԂ֐łBȂ΁A-1 Ԃ܂BNewPath  }
{ OldPath ́AtpXł鎖OƂȂĂ܂B}
function TFrameForm.IndexOfOldPath(NewPath: String; OldPath: String): Integer;
var
  i, j: Integer;
  NPath, OPath: String;
  S: String;
begin
  Result := -1;
  if OldPath = '' then
    Exit;

  if NewPath = '' then // hCu\̏ꍇ
  begin
    for i := 0 to SRecs.Count - 1 do
    begin
      if (SRecs.Recs[i].Name)[1] = OldPath[1] then
      begin
        Result := i;
        Break;
      end;
    end;
    Exit;
  end;

  i := Length(NewPath);
  while i > 0 do
  begin
    if (NewPath[i] = '\') and (ByteType(NewPath, i) = mbSingleByte) then
      Break;
    Dec(i);
  end;
  if i < 2 then
    Exit;
  NPath := Copy(NewPath, 1, i - 1); // NewPath ̃ChJ[h

  j := Length(OldPath);
  while j > 0 do
  begin
    if (OldPath[j] = '\') and (ByteType(OldPath, i) = mbSingleByte) then
      Break;
    Dec(j);
  end;
  if j < 2 then
    Exit;
  OPath := Copy(OldPath, 1, j - 1); // OldPath ̃ChJ[h

  if (Pos(NPath, OPath) <> 1) or (NPath = OPath) then
    Exit;

  S := Copy(OPath, Length(NPath) + 2, Length(OPath) - (Length(NPath) + 1));
  i := 1;
  while i <= Length(S) do
  begin
    if (S[i] = '\') and (ByteType(S, i) = mbSingleByte) then
      Break;
    Inc(i);
  end;
  if i <= Length(S) then
    S := Copy(S, 1, i - 1);
  Result := SRecs.IndexOf(S);
end;

procedure TFrameForm.FormShow(Sender: TObject);
var
  OSInfo: OSVERSIONINFO;
  Path: String;
  ExeName: String;
  i: Integer;
begin
  MajorVersion := 6;
  OSInfo.dwOSVersionInfoSize := SizeOf(OSVERSIONINFO);
  if GetVersionEx(OSInfo) then
    MajorVersion := OSInfo.dwMajorVersion;

  ExeName := ExtractFilePath(Application.ExeName) + 'Binary.exe';
  if not FileExists(ExeName) then
  begin
    N29.Enabled := False;
    Space1.Enabled := False;
  end;

  { AvP[V̊ep[^֌W̏ }
  Parameter1.Init; // Parameter1 Ăep[^t@C烍[hB

  if Parameter1.Count > 0 then // p[^̃[hɐꍇ
  begin
    WindowState := TWindowState(Parameter1['WindowState']);
    Left := Parameter1['Left'];
    Top := Parameter1['Top'];
    ClientWidth := Parameter1['ClientWidth'];
    ClientHeight := Parameter1['ClientHeight'];
    Panel1.Width := Parameter1['Panel1.Width'];
    ListView1.Font.Name := Parameter1.VStrings['FontName'];
    ListView1.Font.Size := Parameter1['FontSize'];
    ListView1.Font.Style := Parameter1.VFontStyles['FontStyle'];
    ListView1.Font.Color := Parameter1['FontColor'];
    ListView1.Columns.Items[0].Width := Parameter1['ListView1.Columns.Items[0].Width'];
    ListView1.Columns.Items[1].Width := Parameter1['ListView1.Columns.Items[1].Width'];
    ListView1.Columns.Items[2].Width := Parameter1['ListView1.Columns.Items[2].Width'];
    ListView1.Columns.Items[3].Width := Parameter1['ListView1.Columns.Items[3].Width'];
    WorkDir := Parameter1.VStrings['WorkDir'];
    Timer1.Enabled := Parameter1.VBools['Clock'];
  end
  else // p[^[hoȂꍇ
  begin
    Parameter1.Add('FileStampN ݒt@C --- ̃t@ĆAҏWȂŉB');
    Parameter1['WindowState'] := Integer(WindowState);
    Parameter1['Left'] := Left;
    Parameter1['Top'] := Top;
    ClientWidth := 723; Parameter1['ClientWidth'] := ClientWidth;
    ClientHeight := 457; Parameter1['ClientHeight'] := ClientHeight;
    Parameter1['Panel1.Width'] := Panel1.Width;
    Parameter1.VStrings['FontName'] := ListView1.Font.Name;
    Parameter1['FontSize'] := ListView1.Font.Size;
    Parameter1.VFontStyles['FontStyle'] := ListView1.Font.Style;
    Parameter1['FontColor'] := ListView1.Font.Color;
    Parameter1['ListView1.Columns.Items[0].Width'] := ListView1.Columns.Items[0].Width;
    Parameter1['ListView1.Columns.Items[1].Width'] := ListView1.Columns.Items[1].Width;
    Parameter1['ListView1.Columns.Items[2].Width'] := ListView1.Columns.Items[2].Width;
    Parameter1['ListView1.Columns.Items[3].Width'] := ListView1.Columns.Items[3].Width;
    WorkDir := ''; // JgfBNgӖB
    Parameter1.VStrings['WorkDir'] := WorkDir;
    Parameter1.VBools['Clock'] := Timer1.Enabled;
    Parameter1['WLeft'] := 192;
    Parameter1['WTop'] := 114;
    Parameter1.VStrings['WStr'] := 'Readme.txt';
    Parameter1['GLeft'] := 505;
    Parameter1['GTop'] := 178;
    Parameter1.VStrings['GStr'] := 'Integer';
    Parameter1.VFontStyles['WGFontStyle'] := [fsBold];
    Parameter1.VBools['WGStamp'] := False;
  end;

  Icon := TIcon.Create;
  GetSystemIcons(16); // 16~16 Pixels ̃VXeACR 16 B
  SRecs := TSearchRecs.Create;
  // SRecs.DotOption := True;
  WildCard := '*.*';
  WildLen := Length(WildCard);

  UndoFlag := False; // AhEEhE True ɂȂtO
  UndoIndex := -1; // AhẼCfbNXl(ʏ́A0 ` UndoMax - 1)
  UndoPath := TStringList.Create;
  UndoPath.Clear;
  for i := 0 to UndoMax - 1 do
    UndoPath.Add('<'); // '<' ́Af[^܂Ƃ

  Path := WorkDir;
  if (Path <> '') and (Path[Length(Path)] <> '\') then
    Path := Path + '\';
  Path := Path + WildCard;
  DispData(Path); // ƃfBNg̑SẴt@C\

  SpecialDir := TStringList.Create;
  SpecialDir.Clear;
  for i := 0 to 9 do
  begin
    Path := GetSpecialFolder(CSIDL[i]);
    if Path <> '' then
      SpecialDir.Add(Path)
    else
      ComboBox1.Items.Delete(i);
  end;
  SpecialDir.Add('');
  ComboBox1.ItemIndex := 0;
end;

procedure TFrameForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  { AvP[V̊ep[^̕ۑ }
  Parameter1['WindowState'] := Integer(WindowState);
  Parameter1['Left'] := Left;
  Parameter1['Top'] := Top;
  Parameter1['ClientWidth'] := ClientWidth;
  Parameter1['ClientHeight'] := ClientHeight;
  Parameter1['Panel1.Width'] := Panel1.Width;
  Parameter1.VStrings['FontName'] := ListView1.Font.Name;
  Parameter1['FontSize'] := ListView1.Font.Size;
  Parameter1.VFontStyles['FontStyle'] := ListView1.Font.Style;
  Parameter1['FontColor'] := ListView1.Font.Color;
  Parameter1['ListView1.Columns.Items[0].Width'] := ListView1.Columns.Items[0].Width;
  Parameter1['ListView1.Columns.Items[1].Width'] := ListView1.Columns.Items[1].Width;
  Parameter1['ListView1.Columns.Items[2].Width'] := ListView1.Columns.Items[2].Width;
  Parameter1['ListView1.Columns.Items[3].Width'] := ListView1.Columns.Items[3].Width;
  Parameter1.VStrings['WorkDir'] := WorkDir;
  Parameter1.VBools['Clock'] := Timer1.Enabled;
  Parameter1.SaveToFile;

  UndoPath.Free;
  SpecialDir.Free;
  SRecs.Clear;
  SRecs.Free;
  Icon.Free;
end;

procedure TFrameForm.ListView1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ListView1.IsEditing or (Shift <> []) then
    Exit;

  if Tag = -1 then
  begin
    Tag := 0;
    Exit;
  end;

  if (Key = VK_BACK) then
    N6Click(Sender)
  else if Key = VK_RETURN then
    Open1Click(Sender)
  else if Key = VK_SPACE then
  begin
    if N29.Enabled = True then
      N29Click(Sender);
  end
  else if Key = WORD(220) then // \ L[
    N7Click(Sender)
  else if Key = WORD('L') then
    L1Click(Sender)
  else if Key = WORD('C') then
    N5Click(Sender)
  else if Key = WORD('W') then
    N11Click(Sender);
end;

procedure TFrameForm.Show1Click(Sender: TObject);
begin
  if UndoIndex > 0 then
    N26.Enabled := True
  else
    N26.Enabled := False;

  if (UndoIndex < UndoMax - 1) and (UndoPath[UndoIndex + 1] <> '<') then
    N27.Enabled := True
  else
    N27.Enabled := False;

  if ImageList1.Width = 16 then
  begin
    N16161.Checked := True;
    N16161.Enabled := False;
    N32321.Checked := False;
    N32321.Enabled := True;
  end
  else
  begin
    N16161.Checked := False;
    N16161.Enabled := True;
    N32321.Checked := True;
    N32321.Enabled := False;
  end;

  if Timer1.Enabled then
    N13.Checked := True
  else
    N13.Checked := False;
end;

procedure TFrameForm.N16161Click(Sender: TObject);
begin
  GetSystemIcons(16); // 16~16 Pixels ̃VXeACR 16 B
  PaintData;
end;

procedure TFrameForm.N32321Click(Sender: TObject);
begin
  GetSystemIcons(32); // 32~32 Pixels ̃VXeACR 16 B
  PaintData;
end;

procedure TFrameForm.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  if Selected and (Tag = 0) then
    DispInfor(Item.Index); // ListView1.Selected.Index
end;

procedure TFrameForm.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TFrameForm.Button1Click(Sender: TObject);
var
  i: Integer;
  Dir: String;
  N1, N2: String;
  R: TSearchRec;
  FileOpSt: TSHFILEOPSTRUCT;
begin
  ListView1.SetFocus;
  if (ListView1.SelCount = 0) or (SRecs.FullPath = '') then
    Exit;

  N1 := ListView1.Selected.Caption;
  N2 := Edit1.Text;
  if N1 <> N2 then
  begin
    Dir := Copy(SRecs.FullPath, 1, Length(SRecs.FullPath) - WildLen);
    N1 := Dir + N1 + #0#0;
    N2 := Dir + N2 + #0#0;
    with FileOpSt do
    begin
      Wnd := Handle;
      wFunc := FO_RENAME;
      pFrom := PChar(N1);
      pTo := PChar(N2);
      fFlags := 0;
      fAnyOperationsAborted := False;
      hNameMappings := Nil;
      lpszProgressTitle := Nil;
    end;
    if SHFileOperation(FileOpSt) = 0 then
    begin
      i := ListView1.Selected.Index;
      ListView1.Selected.Caption := Edit1.Text;
      R := SRecs.Recs[i];
      R.Name := Edit1.Text;
      SRecs.Recs[i] := R;
      ListView1.Selected := ListView1.Items.Item[i];
      // DispData(SRecs.Path);
    end;
  end;
end;

procedure TFrameForm.N4Click(Sender: TObject);
begin
  DispData(SRecs.Path);
end;

procedure TFrameForm.Open1Click(Sender: TObject);
var
  S, O: String;
  R: TSearchRec;
  ExeName: String;
  hI: Longint;
begin
  if ListView1.SelCount = 0 then
    Exit;

  R := SRecs.Recs[ListView1.Selected.Index];
  if SRecs.FullPath = '' then // hCu
  begin
    if R.Size <> -1 then
    begin
      S := Copy(R.Name, 1, 2) + '\' + WildCard;
      DispData(S); // Root Directory
    end;
  end
  else if R.Attr and faDirectory > 0  then // fBNg
  begin
    S := SRecs.FullPath;
    S := Copy(S, 1, Length(S) - WildLen) + R.Name + '\' + WildCard;
    DispData(S);
  end
  else // t@C
  begin
    ExeName := ExtractFilePath(Application.ExeName) + 'Binary.exe';
    S := SRecs.FullPath;
    S := Copy(S, 1, Length(S) - WildLen) + R.Name;
    hI := ShellExecute(Handle, PChar('open'), PChar(S), Nil, Nil, SW_SHOW);
    if hI = SE_ERR_NOASSOC then
    begin
      if R.Size > 256 * 1024 then O := '/T /N4 /S64 '
      else O := '/T /N0 /S16 ';
      ShellExecute(Handle, PChar('open'), PChar('"' + ExeName + '"'),
                   PChar(O + '"' + S + '"'), Nil, SW_SHOW);
    end;
  end;
end;

procedure TFrameForm.A1Click(Sender: TObject);
var
  i: Integer;
begin
  Tag := 1;
  for i := 0 to ListView1.Items.Count - 1 do
    ListView1.Items.Item[i].Selected := True;
  Tag := 0;
end;

procedure TFrameForm.Button2Click(Sender: TObject);
var
  i, j: Integer;
  rs: Integer;
  Attr: Integer;
  S: String;
  Dir: String;
  ListItem: TListItem;
begin
  ListView1.SetFocus;
  if (ListView1.SelCount = 0) or (SRecs.FullPath = '') then
    Exit;

  Attr := 0;
  S := UpperCase(Edit2.Text);
  if Pos('A', S) <> 0 then Attr := Attr or faArchive;
  if Pos('R', S) <> 0 then Attr := Attr or faReadOnly;
  if Pos('H', S) <> 0 then Attr := Attr or faHidden;
  if Pos('S', S) <> 0 then Attr := Attr or faSysFile;
  Dir := Copy(SRecs.FullPath, 1, Length(SRecs.FullPath) - WildLen);

  j := 0;
  for i := 0 to ListView1.Items.Count - 1 do
  begin
    ListItem := ListView1.Items.Item[i];
    if ListItem.Selected and ((SRecs.Recs[i].Attr and faVolumeID) = 0) then
    begin
      if (SRecs.Recs[i].Attr and faDirectory) > 0 then
        rs := FileSetAttr(Dir + ListItem.Caption, Attr or faDirectory)
      else
        rs := FileSetAttr(Dir + ListItem.Caption, Attr);
      if rs = 0 then
        Inc(j);
    end;
  end;
  if j > 0 then
    DispData(SRecs.Path);
end;

procedure TFrameForm.Button4Click(Sender: TObject);
var
  i: Integer;
  AllStamp: Boolean;
  DateTime: TDateTime;
  Dir: String;
  ListItem: TListItem;
begin
  ListView1.SetFocus;
  if (ListView1.SelCount = 0) or (SRecs.FullPath = '') then
    Exit;

  if ((GetAsyncKeyState(VK_SHIFT) and $8000) <> 0) then
  begin
    AllStamp := True;
    Edit4.Text := Edit3.Text;
    Edit5.Text := Edit3.Text;
  end
  else
    AllStamp := False;

  DateTime := StrToDateTime(Edit3.Text);
  Dir := Copy(SRecs.FullPath, 1, Length(SRecs.FullPath) - WildLen);

  for i := 0 to ListView1.Items.Count - 1 do
  begin
    ListItem := ListView1.Items.Item[i];
    if ListItem.Selected and ((SRecs.Recs[i].Attr and faVolumeID) = 0) then
    begin
      SetTimeStamp(Dir + ListItem.Caption, ftCreationTime, DateTime);
      if AllStamp then
      begin
        SetTimeStamp(Dir + ListItem.Caption, ftLastAccessTime, DateTime);
        SetTimeStamp(Dir + ListItem.Caption, ftLastWriteTime, DateTime);
      end;
    end;
  end;
  DispData(SRecs.Path);
end;

procedure TFrameForm.Button6Click(Sender: TObject);
var
  i: Integer;
  AllStamp: Boolean;
  DateTime: TDateTime;
  Dir: String;
  ListItem: TListItem;
begin
  ListView1.SetFocus;
  if (ListView1.SelCount = 0) or (SRecs.FullPath = '') then
    Exit;

  if ((GetAsyncKeyState(VK_SHIFT) and $8000) <> 0) then
  begin
    AllStamp := True;
    Edit3.Text := Edit4.Text;
    Edit5.Text := Edit4.Text;
  end
  else
    AllStamp := False;

  DateTime := StrToDateTime(Edit4.Text);
  Dir := Copy(SRecs.FullPath, 1, Length(SRecs.FullPath) - WildLen);

  for i := 0 to ListView1.Items.Count - 1 do
  begin
    ListItem := ListView1.Items.Item[i];
    if ListItem.Selected and ((SRecs.Recs[i].Attr and faVolumeID) = 0) then
    begin
      SetTimeStamp(Dir + ListItem.Caption, ftLastAccessTime, DateTime);
      if AllStamp then
      begin
        SetTimeStamp(Dir + ListItem.Caption, ftCreationTime, DateTime);
        SetTimeStamp(Dir + ListItem.Caption, ftLastWriteTime, DateTime);
      end;
    end;
  end;
  DispData(SRecs.Path);
end;

procedure TFrameForm.Button8Click(Sender: TObject);
var
  i: Integer;
  AllStamp: Boolean;
  DateTime: TDateTime;
  Dir: String;
  ListItem: TListItem;
begin
  ListView1.SetFocus;
  if (ListView1.SelCount = 0) or (SRecs.FullPath = '') then
    Exit;

  if ((GetAsyncKeyState(VK_SHIFT) and $8000) <> 0) then
  begin
    AllStamp := True;
    Edit3.Text := Edit5.Text;
    Edit4.Text := Edit5.Text;
  end
  else
    AllStamp := False;

  DateTime := StrToDateTime(Edit5.Text);
  Dir := Copy(SRecs.FullPath, 1, Length(SRecs.FullPath) - WildLen);

  for i := 0 to ListView1.Items.Count - 1 do
  begin
    ListItem := ListView1.Items.Item[i];
    if ListItem.Selected and ((SRecs.Recs[i].Attr and faVolumeID) = 0) then
    begin
      SetTimeStamp(Dir + ListItem.Caption, ftLastWriteTime, DateTime);
      if AllStamp then
      begin
        SetTimeStamp(Dir + ListItem.Caption, ftCreationTime, DateTime);
        SetTimeStamp(Dir + ListItem.Caption, ftLastAccessTime, DateTime);
      end;
    end;
  end;
  DispData(SRecs.Path);
end;

procedure TFrameForm.ListView1ColumnClick(Sender: TObject;
  Column: TListColumn);
var
  st: Integer;
begin
  st := SRecs.SortType;
  if Column.Index = 0 then
  begin
    if (st and stName > 0) and (st and stReverse = 0) then
      st := stName or stDirectory or stReverse
    else
      st := stName or stDirectory;
  end
  else if Column.Index = 1 then
  begin
    if (st and stSize > 0) and (st and stReverse = 0) then
      st := stSize or stDirectory or stReverse
    else
      st := stSize or stDirectory;
  end
  else if Column.Index = 3 then
  begin
    if (st and stTime > 0) and (st and stReverse = 0) then
      st := stTime or stDirectory or stReverse
    else
      st := stTime or stDirectory;
  end;

  if Column.Index <> 2 then
  begin
    Srecs.SortType := st;
    PaintData;
  end;
end;

procedure TFrameForm.Edit8KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  Path: String;
begin
  if Key = VK_Return then
  begin
    if SRecs.FullPath = '' then // hCu\Ăꍇ
      Path := ''
    else
      Path := Copy(SRecs.FullPath, 1, Length(SRecs.FullPath) - WildLen);

    if Edit8.Text = '' then
      Edit8.Text := '*.*'; // Default Card
    WildCard := Edit8.Text;
    WildLen := Length(WildCard);

    if Path <> '' then
      Path := Path + WildCard;
      
    DispData(Path);
  end;
end;

procedure TFrameForm.N5Click(Sender: TObject);
begin
  DispData(WildCard);
end;

procedure TFrameForm.N6Click(Sender: TObject);
var
  i: Integer;
  S: String;
begin
  S := SRecs.FullPath;
  if S = '' then
    Exit;

  i := Length(S) - (WildLen + 1);
  while i > 1 do
  begin
    Dec(i);
    if (S[i] = '\') and (ByteType(S, i) = mbSingleByte) then
      Break;
  end;

  if i = 1 then
    S := ''
  else
    S := Copy(S, 1, i) + WildCard;

  DispData(S);
end;

procedure TFrameForm.N7Click(Sender: TObject);
begin
  if Length(SRecs.FullPath) > 3 then
    DispData(Copy(SRecs.FullPath, 1, 3) + WildCard); // Root Directory
end;

procedure TFrameForm.L1Click(Sender: TObject);
begin
  if SRecs.FullPath <> '' then
    DispData('');
end;

procedure TFrameForm.K1Click(Sender: TObject);
begin
  DoDeleteFiles(True);
end;

procedure TFrameForm.Delete1Click(Sender: TObject);
begin
  DoDeleteFiles(False);
end;

procedure TFrameForm.N9Click(Sender: TObject);
var
  DTime: TDateTime;
  S: String;
begin
  DTime := Now;
  S := FormatDateTime('yyyy/mm/dd hh:nn:ss', DTime);
  Edit3.Text := S;
  Edit4.Text := S;
  Edit5.Text := S;
  ListView1.SetFocus;
end;

procedure TFrameForm.F1Click(Sender: TObject);
var
  fs: Integer;
begin
  FontDialog1.Font := ListView1.Font;
  if FontDialog1.Execute then
  begin
    fs := Abs(FontDialog1.Font.Size);
    if (fs >= 9) and (fs <= 12) then
    begin
      Font := FontDialog1.Font;
      ListView1.Font := FontDialog1.Font;
      Parameter1.VStrings['FontName'] := FontDialog1.Font.Name;
      Parameter1['FontSize'] := FontDialog1.Font.Size;
      Parameter1.VFontStyles['FontStyle'] := FontDialog1.Font.Style;
      Parameter1['FontColor'] := FontDialog1.Font.Color;
    end;
  end;
end;

procedure TFrameForm.SearchforHelpOn1Click(Sender: TObject);
var
  FileName: TFileName;
begin
  FileName := ExtractFilePath(Application.ExeName) + 'ReadmeF.txt';
  ShellExecute(Handle, PChar('open'), PChar(FileName), Nil, Nil, SW_SHOW);
end;

procedure TFrameForm.About1Click(Sender: TObject);
begin
  ShellAbout(Handle, PChar(Application.Title),
             #13#10 + 'FileStampN  Version 1.0 Copyright (C) 2017 ` 2023 seizo',
             Application.Icon.Handle);
end;

procedure TFrameForm.Copy1Click(Sender: TObject);
var
  i: Integer;
  Files: TStringList;
  Dir: String;
  ListItem: TListItem;
  Effect: Word;
begin
  // ListView1.SetFocus;
  if (ListView1.SelCount = 0) or (SRecs.FullPath = '') then
    Exit;

  Dir := Copy(SRecs.FullPath, 1, Length(SRecs.FullPath) - WildLen);
  Files := TStringList.Create;
  try
    for i := 0 to ListView1.Items.Count - 1 do
    begin
      ListItem := ListView1.Items.Item[i];
      if ListItem.Selected then
        Files.Add(Dir + ListItem.Caption);
    end;
    Effect := DROPEFFECT_COPY or DROPEFFECT_LINK;
    SetCF_HDROPList(Files, Effect);
  finally
    Files.Free;
  end;
end;

procedure TFrameForm.Paste1Click(Sender: TObject);
var
  i: Integer;
  Count: Integer;
  Effect: Word;
  Files: TStringList;
  FileOpSt: TSHFILEOPSTRUCT;
  Dir: String;
  CopyFile: String;
  n: Integer;
begin
  // ListView1.SetFocus;
  if SRecs.FullPath = '' then
    Exit;

  Files := TStringList.Create;
  try
    Count := GetCF_HDROPList(Files, Effect);
    if Count > 0 then
    begin
      n := Length(SRecs.FullPath) - (WildLen + 1);
      if n = 2 then // Root Directory
        n := 3;
      Dir := Copy(SRecs.FullPath, 1, n) + #0#0;

      with FileOpSt do
      begin
        Wnd := Handle;
        wFunc := FO_COPY;
        pTo := PChar(Dir);
        fFlags := 0;
        fAnyOperationsAborted := False;
        hNameMappings := Nil;
        lpszProgressTitle := Nil;
      end;

      CopyFile := '';
      for i := 0 to Count - 1 do
        CopyFile := CopyFile + Files.Strings[i] + #0;
      CopyFile := CopyFile + #0;
      FileOpSt.pFrom := PChar(CopyFile);
      n := SHFileOperation(FileOpSt);
      if n = 0 then
      begin
        DispData(SRecs.Path);
        ListView1.Selected.Selected := False;
        for i := 0 to Files.Count - 1 do
          Files.Strings[i] := ExtractFileName(Files.Strings[i]);
        for i := 0 to SRecs.Count - 1 do
        begin
          if Files.IndexOf(SRecs.Recs[i].Name) <> -1 then
            ListView1.Items.Item[i].Selected := True;
        end;
        ListView1.ItemFocused := ListView1.Selected;
      end;
    end;
  finally
    Files.Free;
  end;
end;

procedure TFrameForm.Button3Click(Sender: TObject);
begin
  N9Click(Sender);
end;

procedure TFrameForm.ListView1Edited(Sender: TObject; Item: TListItem;
  var S: String);
var
  i: Integer;
  Dir: String;
  N1, N2: String;
  R: TSearchRec;
  FileOpSt: TSHFILEOPSTRUCT;
begin
  Tag := -1;
  
  if SRecs.FullPath = '' then
    S := Item.Caption;

  N1 := Item.Caption;
  N2 := S;
  if N1 <> N2 then
  begin
    Dir := Copy(SRecs.FullPath, 1, Length(SRecs.FullPath) - WildLen);
    N1 := Dir + N1 + #0#0;
    N2 := Dir + N2 + #0#0;
    with FileOpSt do
    begin
      Wnd := Handle;
      wFunc := FO_RENAME;
      pFrom := PChar(N1);
      pTo := PChar(N2);
      fFlags := 0;
      fAnyOperationsAborted := False;
      hNameMappings := Nil;
      lpszProgressTitle := Nil;
    end;
    if SHFileOperation(FileOpSt) = 0 then
    begin
      i := Item.Index;
      Edit1.Text := S;
      R := SRecs.Recs[i];
      R.Name := S;
      SRecs.Recs[i] := R;
      // ListView1.Selected := ListView1.Items.Item[i];
      // DispData(SRecs.Path);
    end
    else
      S := Item.Caption;
  end;
end;

procedure TFrameForm.Rename1Click(Sender: TObject);
begin
  if (SRecs.FullPath <> '') and (ListView1.SelCount <> 0) then
    ListView1.Selected.EditCaption;
end;

procedure TFrameForm.ListView1Editing(Sender: TObject; Item: TListItem;
  var AllowEdit: Boolean);
begin
  Tag := -1;
end;

procedure TFrameForm.Button5Click(Sender: TObject);
begin
  DoDeleteFiles(True);
end;

procedure TFrameForm.Button12Click(Sender: TObject);
begin
  DoDeleteFiles(False);
end;

procedure TFrameForm.N11Click(Sender: TObject);
var
  S: String;
begin
  S := Parameter1.VStrings['WorkDir'];
  if S <> '' then
  begin
    if S[Length(S)] <> '\' then
      S := S + '\';
    S := S + WildCard;
  end;
  DispData(S);
end;

procedure TFrameForm.Button7Click(Sender: TObject);
var
  Handle: Integer;
  Dir: String;
begin
  ListView1.SetFocus;
  Dir := Copy(SRecs.FullPath, 1, Length(SRecs.FullPath) - WildLen);

  if FileExists(Dir + Edit1.Text) or DirectoryExists(Dir + Edit1.Text) then
    ShowMessage(Dir + Edit1.Text + ' ͂łɑ݂܂B')
  else
  begin
    Handle := FileCreate(Dir + Edit1.Text);
    if Handle > 0 then
      FileClose(Handle);
    DispData(SRecs.Path);
  end;
end;

procedure TFrameForm.Timer1Timer(Sender: TObject);
var
  DTime: TDateTime;
  S: String;
begin
  DTime := Now;
  S := FormatDateTime('yyyy/mm/dd hh:nn:ss', DTime);
  Caption := 'FileStampN Version 1.0  -  ' + S
end;

procedure TFrameForm.N13Click(Sender: TObject);
begin
  if Timer1.Enabled then
  begin
    Timer1.Enabled := False;
    Caption := 'FileStampN Version 1.0';
  end
  else
    Timer1.Enabled := True;
end;

procedure TFrameForm.Rename2Click(Sender: TObject);
begin
  if (SRecs.FullPath <> '') and (ListView1.SelCount <> 0) then
    ListView1.Selected.EditCaption;
end;

procedure TFrameForm.Open2Click(Sender: TObject);
begin
  Open1Click(Sender);
end;

procedure TFrameForm.N14Click(Sender: TObject);
begin
  N5Click(Sender);
end;

procedure TFrameForm.N15Click(Sender: TObject);
begin
  N11Click(Sender);
end;

procedure TFrameForm.N16Click(Sender: TObject);
begin
  N6Click(Sender);
end;

procedure TFrameForm.N17Click(Sender: TObject);
begin
  N7Click(Sender);
end;

procedure TFrameForm.N18Click(Sender: TObject);
begin
  L1Click(Sender);
end;

procedure TFrameForm.CtrlC1Click(Sender: TObject);
begin
   Copy1Click(Sender);
end;

procedure TFrameForm.CtrlV1Click(Sender: TObject);
begin
  Paste1Click(Sender);
end;

procedure TFrameForm.Del1Click(Sender: TObject);
begin
  K1Click(Sender);
end;

procedure TFrameForm.ShiftDel1Click(Sender: TObject);
begin
  Delete1Click(Sender);
end;

procedure TFrameForm.CtrlA1Click(Sender: TObject);
begin
  A1Click(Sender);
end;

procedure TFrameForm.CtrlR1Click(Sender: TObject);
begin
  N4Click(Sender);
end;

procedure TFrameForm.F11Click(Sender: TObject);
begin
  SearchforHelpOn1Click(Sender);
end;

procedure TFrameForm.About2Click(Sender: TObject);
begin
  About1Click(Sender);
end;

procedure TFrameForm.N23Click(Sender: TObject);
begin
  Exit;
end;

procedure TFrameForm.N24Click(Sender: TObject);
var
  rs: Boolean;
  i, j: Integer;
  Path: String;
  Dir: String;
  NewDir: String;
begin
  Tag := -1;
  ListView1.SetFocus;
  Path := SRecs.Path;
  Dir := Copy(SRecs.FullPath, 1, Length(SRecs.FullPath) - WildLen);
  NewDir := 'VfBNg';

  rs := False;
  while True do
  begin
    rs := InputQuery('VKިڸ؂̍쐬', 'VfBNg͂ĉB', NewDir);
    if rs = False then
      Break;
    if DirectoryExists(Dir + NewDir) or FileExists(Dir + NewDir) then
      ShowMessage(Dir + NewDir + ' ͂łɑ݂܂B')
    else
    begin
      rs := CreateDir(Dir + NewDir);
      if rs = False then
        ShowMessage(Dir + NewDir + ' 쐬o܂łB')
      else
        Break;
    end;
  end;

  if rs = True then
  begin
    DispData(Path);
    j := SRecs.IndexOf(NewDir);
    if j <> -1 then
    begin
      for i := 0 to ListView1.Items.Count - 1 do
      begin
        if i = j then
        begin
          ListView1.Items.Item[i].Selected := True;
          ListView1.ItemFocused := ListView1.Items.Item[i];
        end
        else
          ListView1.Items.Item[i].Selected := False;
      end;
    end;
  end;
end;

procedure TFrameForm.N25Click(Sender: TObject);
begin
  N24Click(Sender);
end;

procedure TFrameForm.Button9Click(Sender: TObject);
begin
  N24Click(Sender);
end;

procedure TFrameForm.Button10Click(Sender: TObject);
var
  Path: String;
  i, j, n: Integer;
begin
  ListView1.SetFocus;
  if SRecs.FullPath = '' then
    Exit;

  n := ComboBox1.Items.Count;
  Path := ExtractFileDir(SRecs.FullPath);
  SpecialDir.Strings[n - 1] := Path;
  ComboBox1.Items.Strings[n - 1] := Path;

  j := n - 1;
  for i := 0 to n - 2 do
  begin
    if Path = SpecialDir.Strings[i] then
    begin
      j := i;
      Break;
    end;
  end;
  ComboBox1.ItemIndex := j;
end;

procedure TFrameForm.CheckComboBox1;
var
  n: Integer;
begin
  if ComboBox1.Text = '' then
    ComboBox1.ItemIndex := 0
  else if ComboBox1.ItemIndex = -1 then
  begin
    n := ComboBox1.Items.Count;
    if DirectoryExists(ComboBox1.Text) then
    begin
      SpecialDir.Strings[n - 1] := ComboBox1.Text;
      ComboBox1.Items.Strings[n - 1] := ComboBox1.Text;
      ComboBox1.ItemIndex := n - 1;
    end
    else
      ComboBox1.ItemIndex := 0;
  end;
end;

procedure TFrameForm.Button11Click(Sender: TObject);
var
  Path: String;
begin
  ListView1.SetFocus;
  CheckComboBox1;
  Path := SpecialDir.Strings[ComboBox1.ItemIndex];
  if Path[Length(Path)] <> '\' then
    Path := Path + '\';
  Path := Path + WildCard;
  DispData(Path);
end;

procedure TFrameForm.S1Click(Sender: TObject);
var
  i, j: Integer;
  Dir: String;
  ListItem: TListItem;
begin
  ListView1.SetFocus;
  if (ListView1.SelCount = 0) or (SRecs.FullPath = '') then
    Exit;

  Dir := Copy(SRecs.FullPath, 1, Length(SRecs.FullPath) - WildLen);
  j := 0;
  for i := 0 to ListView1.Items.Count - 1 do
  begin
    ListItem := ListView1.Items.Item[i];
    if ListItem.Selected and ((SRecs.Recs[i].Attr and faVolumeID) = 0) then
    begin
      if CreateShortCutLink(Dir + ListItem.Caption,
                            SpecialDir.Strings[ComboBox1.ItemIndex],
                            ListItem.Caption + ' ւ̃V[gJbg') then
        Inc(j);
    end;
  end;
  if j > 0 then
    SendMessage(HWND_BROADCAST, WM_SETTINGCHANGE, 0, 0);
end;

procedure TFrameForm.N31Click(Sender: TObject);
begin
  S1Click(Sender);
end;

procedure TFrameForm.ComboBox1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = $0D then
   CheckComboBox1;
end;

procedure TFrameForm.N26Click(Sender: TObject);
var
  S: String;
begin
  if UndoIndex > 0 then
  begin
    Dec(UndoIndex);
    S := UndoPath[UndoIndex];
    if S <> '' then
    begin
      WildCard := ExtractFileName(S);
      WildLen := Length(WildCard);
      Edit8.Text := WildCard;
    end;
    UndoFlag := True;
    DispData(S);
  end;
end;

procedure TFrameForm.N27Click(Sender: TObject);
var
  S: String;
begin
  if (UndoIndex < UndoMax - 1) and (UndoPath[UndoIndex + 1] <> '<') then
  begin
    Inc(UndoIndex);
    S := UndoPath[UndoIndex];
    if S <> '' then
    begin
      WildCard := ExtractFileName(S);
      WildLen := Length(WildCard);
      Edit8.Text := WildCard;
    end;
    UndoFlag := True;
    DispData(S);
  end;
end;

procedure TFrameForm.N28Click(Sender: TObject);
begin
  N26Click(Sender);
end;

procedure TFrameForm.CtrlY1Click(Sender: TObject);
begin
  N27Click(Sender);
end;

procedure TFrameForm.N29Click(Sender: TObject);
var
  S, O: String;
  R: TSearchRec;
  ExeName: String;
begin
  if ListView1.SelCount = 0 then
    Exit;

  R := SRecs.Recs[ListView1.Selected.Index];
  if SRecs.FullPath = '' then // hCu
  begin
    if R.Size <> -1 then
    begin
      S := Copy(R.Name, 1, 2) + '\' + WildCard;
      DispData(S); // Root Directory
    end;
  end
  else if R.Attr and faDirectory > 0  then // fBNg
  begin
    S := SRecs.FullPath;
    S := Copy(S, 1, Length(S) - WildLen) + R.Name + '\' + WildCard;
    DispData(S);
  end
  else // t@C
  begin
    ExeName := ExtractFilePath(Application.ExeName) + 'Binary.exe';
    S := SRecs.FullPath;
    S := Copy(S, 1, Length(S) - WildLen) + R.Name;
    if R.Size > 256 * 1024 then O := '/T /N4 /S64 '
    else O := '/T /N0 /S16 ';
    ShellExecute(Handle, PChar('open'), PChar('"' + ExeName + '"'),
                 PChar(O + '"' + S + '"'), Nil, SW_SHOW);
  end;
end;

procedure TFrameForm.Button13Click(Sender: TObject);
begin
  ListView1.SetFocus;
end;

procedure TFrameForm.Button14Click(Sender: TObject);
begin
  if GrepForm.Visible then
    GrepForm.Close;
  WhereisForm.Show;
end;

procedure TFrameForm.Button15Click(Sender: TObject);
begin
  if WhereisForm.Visible then
    WhereisForm.Close;
  GrepForm.Show;
end;

function TFrameForm.Hook(var Message: TMessage): Boolean;
begin
  case Message.Msg of
    CM_APPKEYDOWN:
      Result := True;
    CM_APPSYSCOMMAND:
      Result := True;
  else
    Result := False;
  end;
end;

procedure TFrameForm.FormCreate(Sender: TObject);
begin
  Application.HookMainWindow(Hook);
end;

procedure TFrameForm.FormDestroy(Sender: TObject);
begin
  Application.UnhookMainWindow(Hook);
end;

procedure TFrameForm.Q1Click(Sender: TObject);
var
  Path: String;
begin
  WindowState := wsNormal;
  Left := 193;
  Top := 114;
  ClientWidth := 723;
  ClientHeight := 457;
  Panel1.Width := 473;
  ListView1.Font.Name := 'lr oSVbN';
  ListView1.Font.Size := 12;
  ListView1.Font.Style := [fsBold];
  ListView1.Font.Color := clBlack;
  Panel2.Font := ListView1.Font;
  Panel3.Font := ListView1.Font;
  ListView1.Columns.Items[0].Width := 150;
  ListView1.Columns.Items[1].Width := 70;
  ListView1.Columns.Items[2].Width := 60;
  ListView1.Columns.Items[3].Width := 170;
  Timer1.Enabled := False;
  Parameter1['WLeft'] := 192;
  Parameter1['WTop'] := 114;
  Parameter1['GLeft'] := 505;
  Parameter1['GTop'] := 178;
  Parameter1.VFontStyles['WGFontStyle'] := [fsBold];
  Parameter1.VBools['WGStamp'] := False;

  if SRecs.FullPath = '' then // hCu\Ăꍇ
    Path := ''
  else
    Path := Copy(SRecs.FullPath, 1, Length(SRecs.FullPath) - WildLen);

  Edit8.Text := '*.*';
  WildCard := Edit8.Text;
  WildLen := Length(WildCard);

  if Path <> '' then
    Path := Path + WildCard;

  DispData(Path);
  ComboBox1.ItemIndex := 0;
  ListView1.SetFocus;
end;

end.

